# Module `druid_instance`

Druid main class.

Create instance of this to start creating components

### See also:

- druid.button
- druid.blocker
- druid.back_handler
- druid.input
- druid.text
- druid.lang_text
- druid.timer
- druid.progress
- druid.grid
- druid.scroll
- druid.slider
- druid.checkbox
- druid.checkbox_group
- druid.radio_group

## Functions

druid:initialize(table, table) | Druid class constructor
druid:create(component, ...) | Create new druid component
druid:remove(component) | Remove component from druid instance.
druid:update(dt) | Druid update function
druid:on_input(action_id, action) | Druid on_input function
druid:on_message(message_id, message, sender) | Druid on_message function
druid:new_button(...) | Create button basic component
druid:new_blocker(...) | Create blocker basic component
druid:new_back_handler(...) | Create back_handler basic component
druid:new_hover(...) | Create hover basic component
druid:new_text(...) | Create text basic component
druid:new_lang_text(...) | Create lang_text basic component
druid:new_timer(...) | Create timer basic component
druid:new_progress(...) | Create progress basic component
druid:new_grid(...) | Create grid basic component
druid:new_scroll(...) | Create scroll basic component
druid:new_slider(...) | Create slider basic component
druid:new_checkbox(...) | Create checkbox basic component
druid:new_input(...) | Create input basic component
druid:new_checkbox_group(...) | Create checkbox_group basic component
druid:new_radio_group(...) | Create radio_group basic component

## Functions

druid:initialize(table, table)
  Druid class constructor

  ### Parameters:

  - table style Druid style module
  - table style Druid style module
druid:create(component, ...)
  Create new druid component

  ### Parameters:

  - component Component Component module
  - ... args Other component params to pass it to component:init function
druid:remove(component)
  Remove component from druid instance. Component `on_remove` function will be invoked, if exist.

  ### Parameters:

  - component Component Component instance
druid:update(dt)
  Druid update function

  ### Parameters:

  - dt number Delta time
druid:on_input(action_id, action)
  Druid on_input function

  ### Parameters:

  - action_id hash Actionid from oninput
  - action table Action from on_input
druid:on_message(message_id, message, sender)
  Druid on_message function

  ### Parameters:

  - message_id hash Messageid from onmessage
  - message table Message from on_message
  - sender hash Sender from on_message
druid:new_button(...)
  Create button basic component

  ### Parameters:

  - ... args button init args

  ### Returns:

  Component button component
druid:new_blocker(...)
  Create blocker basic component

  ### Parameters:

  - ... args blocker init args

  ### Returns:

  Component blocker component
druid:new_back_handler(...)
  Create back_handler basic component

  ### Parameters:

  - ... args back_handler init args

  ### Returns:

  Component back_handler component
druid:new_hover(...)
  Create hover basic component

  ### Parameters:

  - ... args hover init args

  ### Returns:

  Component hover component
druid:new_text(...)
  Create text basic component

  ### Parameters:

  - ... args text init args

  ### Returns:

  Component text component
druid:new_lang_text(...)
  Create lang_text basic component

  ### Parameters:

  - ... args lang_text init args

  ### Returns:

  Component lang_text component
druid:new_timer(...)
  Create timer basic component

  ### Parameters:

  - ... args timer init args

  ### Returns:

  Component timer component
druid:new_progress(...)
  Create progress basic component

  ### Parameters:

  - ... args progress init args

  ### Returns:

  Component progress component
druid:new_grid(...)
  Create grid basic component

  ### Parameters:

  - ... args grid init args

  ### Returns:

  Component grid component
druid:new_scroll(...)
  Create scroll basic component

  ### Parameters:

  - ... args scroll init args

  ### Returns:

  Component scroll component
druid:new_slider(...)
  Create slider basic component

  ### Parameters:

  - ... args slider init args

  ### Returns:

  Component slider component
druid:new_checkbox(...)
  Create checkbox basic component

  ### Parameters:

  - ... args checkbox init args

  ### Returns:

  Component checkbox component
druid:new_input(...)
  Create input basic component

  ### Parameters:

  - ... args input init args

  ### Returns:

  Component input component
druid:new_checkbox_group(...)
  Create checkbox_group basic component

  ### Parameters:

  - ... args checkbox_group init args

  ### Returns:

  Component checkbox_group component
druid:new_radio_group(...)
  Create radio_group basic component

  ### Parameters:

  - ... args radio_group init args

  ### Returns:

  Component radio_group component

generated by LDoc 1.4.6 Last updated 2020-03-22 15:31:43